//////////////////////////////////////////////////////////////////////
//
//	OptLogBase.h: interface of the Log class.
//
//	Written By: Matthias Wacker
//
//////////////////////////////////////////////////////////////////////

#ifndef _OPT_LOG_EMPTY_H_
#define _OPT_LOG_EMPTY_H_

#include <string>
#include <sstream>
#include "core/optimization/blackbox/OptLogBase.h"

namespace OPTIMIZATION
{
  /*!
      base class for all log classes
  */
  class EmptyLog : public OptLogBase
  {
    public:
      
          /*!
              Constructor.
      */
      EmptyLog(){};
          
          /*!
              Destructor.
          */
          virtual ~EmptyLog(){};
      
      

    protected:

      /**! Write error message to an output device (file, stdio, etc.)
      */
      virtual void writeLogError(const char* szMessage){};

      /**! Write warning message to an output device (file, stdio, etc.)
      */
      virtual void writeLogWarning(const char* szMessage){};

      /**! Write trace message to an output device (file, stdio, etc.)
      */
      virtual void writeLogTrace(const char* szMessage) {};
    
  }; //class
}//namespace



#endif
