/*!
	@file: optimization/FileLog.cpp
	@author: Matthias Wacker


*/


#include "optimization/FileLog.h"
#include <iostream>

using namespace std;
using namespace OPTIMIZATION;

FileLog::FileLog( std::string file)
{
	// open file
	m_stream.open(file.c_str(), ios_base::out);
}

FileLog::~FileLog()
{
	// close file
	m_stream.close();
}

void FileLog::writeLogError(const char* szMessage)
{
	toFile(szMessage);
}

void FileLog::writeLogWarning(const char* szMessage)
{
	toFile(szMessage);
}

void FileLog::writeLogTrace(const char* szMessage)
{
	toFile(szMessage);
}

void FileLog::toFile(const char* szMessage)
{
	if(m_stream.good())
	{
		m_stream << szMessage << endl;
		m_stream.flush();
	}
	else
	{
		std::cerr << " the log file stream is bad! " <<endl;
	}
}
