/// @file: 	optimization/OptTestSuite.h
/// @author:	Matthias Wacker
/// @date:	2009-10-05
///
///	
///
///	

#ifndef _OPTTESTSUITE_H_
#define _OPTTESTSUITE_H_

#include "SimpleOptTestGrid.h"

namespace OPTIMIZATION
{
  ///
  ///	class that implements a test suite for the optimization lib
  ///
  class OptTestSuite 
  {
  public:

    ///
    /// Default constructor
    ///
    OptTestSuite(){};

    ///
    /// Default destructor
    ///
    ~OptTestSuite(){};

    ///
    /// runs all implemented tests, including output 
    ///
    ///
    void runAllTests();

  private:

    /// run simple opt test grid
    void runSimpleOptTestGrid();

    /// instert optimizers
    void insertOptsInGrid(SimpleOptTestGrid &testGrid, std::vector<Optimizer*> &opts);

    /// insert opt probs
    void insertOptProbsInGrid(SimpleOptTestGrid &testGrid, std::vector<CostFunction*> &cfns);

  }; //class
}//namespace

#endif // _OPTTESTSUITE_H_
