#ifndef _TESTGRADIENTDESCENT_H
#define _TESTGRADIENTDESCENT_H

#include <cppunit/extensions/HelperMacros.h>
#include "optimization/GradientDescentOptimizer.h"

/**
 * @brief CppUnit-Testcase for Gradient Descent Optimization
 * @author Johannes Ruehle
 * @date 12-10-2012
 */
class TestGradientDescent : public CppUnit::TestFixture {

    CPPUNIT_TEST_SUITE( TestGradientDescent );
    
    CPPUNIT_TEST(testGD_1Dim);
    CPPUNIT_TEST(testGD_2Dim);
    
    CPPUNIT_TEST_SUITE_END();
  
 private:
 
 public:
    void setUp();
    void tearDown();

    /**
    * @brief Test of 1D optimziation with a simple convex cost function
    * @author Johannes Ruehle
    * @date 12-10-2012
    */      
    void testGD_1Dim();

    /**
    * @brief Test of 2D optimziation with a simple convex cost function
    * @author Johannes Ruehle
    * @date 12-10-2012
    */    
    void testGD_2Dim();

};

#endif // _TESTGRADIENTDESCENT_H
